/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

write_pass (node)
Node *node;
{
	int i, type;
	PtFrN fun;

	if (node == NN)
		return 0;

#ifdef DEBUG
	NODE_write (node) = 1;
#endif

	type = node->com.type;

	if ((fun = function [PASS_WRITE] [0] [type]) != (PtFrN) 0)
		(*fun) (node);
}

write_pass_childs (node)
Node *node;
{
	int i, type;

	if (node == NN)
		return 0;

	type = node->com.type;

	for (i = 0; i < node_nodes (type); i++)
		write_pass (node->com.node [i]);
}

write_default (node)
Node *node;
{
	int type;
	char str [2];

	if (node == NN)
		return;

	type = node->com.type;
	
	switch (node_class (type)) {
	case LIT:
		sprintf (str, "%c", type);
		ostr (str);
		break;
	case TERM:
		if (node->com.str == (char*) 0)
                        /* ##BEG##, 10/28/1991, ZEKI */                        
                        switch (type) {
                        case DIRALIGN :
                             ostr("ALIGN");break;
                        case DIRDECOMPOSE :
                             ostr("DECOMPOSITION");break;
                        case DIRDISTRIBUTE : 
                             ostr("DISTRIBUTE");break;
                        case DIRCYCLIC: 
                             ostr("CYCLIC");break;
                        case DIRBLOCK: 
                             ostr("BLOCK");break;
                        case DIRWITH: 
                             ostr("WITH");break;
                        /* ##END## */
			default : ostr (node_Symbol (type));break;
			   }
		else
			ostr (node->com.str);
		break;
	case NONTERM:
		write_pass_childs (node);
		break;
	default:
		sprintf (serr, "type %d, class %d", type, node_class (type));
		syserr (serr);
	}
}


/*******************************************************************************/
write_EndStmt (node)
Node *node;
{
/*	auto_end_write (); ZEKI */

	otab ();
	oEND ();
}

write_ProgramUnit (unit)
Node *unit;
{
	static int first_call = 1;
	Node *statement_list, *statement, *temp;
	int sta_num;

	statement_list = list_invert (unit->ProgramUnit.SpecificationPartBlock);

	if (!first_call) { /* puts blank line between program units */
		ostart ();
		odon ();
		oend ();
	}
	else
		first_call = 0;

	sta_num = 0;
	for (LIST_LOOP (statement, statement_list, temp)) {
		if (flag_cubix && sta_num++ == 0)
			cubix_write_top_sta (statement);
		else  
                        write_pass (statement);
	      
	}          
}


/* BOZKUS */

comm_ProgramUnit (unit)
Node *unit;
{
	static int first_call = 1;
	Node *statement_list, *statement, *temp;
	int sta_num;

	statement_list = list_invert (unit->ProgramUnit.SpecificationPartBlock);

	
	sta_num = 0;
	for (LIST_LOOP (statement, statement_list, temp)) {
		if (flag_cubix && sta_num++ == 0)
			cubix_write_top_sta (statement);
		else  

                     statement=comm_pass (statement);
	      
	}          
}

/* END */
